//+------------------------------------------------------------------+
//|                                                          WPR.mq4 |
//|  wpr obos zones                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//2008fxtsd   ki 
//(zones - mladenn's Lag1.0)

#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property copyright  "www.forex-tsd.com/"
#property link       ""  

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Orange

#property indicator_maximum 0
#property indicator_minimum -100

//---- 

extern int WPR_Period   = 55;

extern double Level1        = -20; 
extern double Level2        = -50;
extern double Level3        = -80;
extern bool   ShowLevels    = true;  
extern color  Level1Color   = C'0,0,72';
extern color  Level2Color   = C'33,56,56';
extern color  Level3Color   = C'72,0,0';




extern string   note_Price = "0C,1O 2H3L,4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   MA_Method_ = "SMA0 EMA1 SMMA2 LWMA3";

//---- 

double Buffer0[];

string  ShortName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|

int init()
  {
//---- 
   
   SetIndexBuffer(0, Buffer0);
   SetIndexStyle (0, DRAW_LINE);
   SetIndexLabel (0, "WPR("+WPR_Period+")");


//----    
 ShortName=("WPR ("+WPR_Period+") ");

   IndicatorShortName(ShortName);
//   IndicatorShortName("WPR ("+WPR_Period+") ");

   return(0);
  }

//----

int deinit()
  {
   
   DeleteBounds();
   return(0);
  }

//+---

int start()
  {
 

   int i,limit,    CountedBars=IndicatorCounted();
   if (CountedBars<0) return(-1);
   if (CountedBars>0) CountedBars--;

      limit= Bars-CountedBars;
      for (i=limit;i>=0;i--)

      {
   Buffer0[i] = iWPR(NULL,0,WPR_Period,i);
      }
     
//----  
   
   if (ShowLevels) UpdateBounds();

   return(0);
 }
//+-------


//
//
//                                  obos zones from mladen's laguerre v1.0

void DeleteBounds()
{
   ObjectDelete(ShortName+"-1");
   ObjectDelete(ShortName+"-2");
   ObjectDelete(ShortName+"-3");
}
void UpdateBounds()
{
   if (Level1 < 0) SetUpBound1(ShortName+"-1",0.0000     ,Level1);
   if (Level2 < 0) SetUpBound2(ShortName+"-2",Level2*1.02,Level2*0.98);
   if (Level3 < 0) SetUpBound3(ShortName+"-3",Level3     ,-100  );
}

//--

void SetUpBound1(string name1, double up, double down,int objType=OBJ_RECTANGLE)
{
   if (ObjectFind(name1) == -1)
      {
         ObjectCreate(name1,objType,WindowFind(ShortName),0,0);
         ObjectSet(name1,OBJPROP_PRICE1,up);
         ObjectSet(name1,OBJPROP_PRICE2,down);
         ObjectSet(name1,OBJPROP_COLOR,Level1Color);
         ObjectSet(name1,OBJPROP_BACK,true);
         ObjectSet(name1,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name1,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name1,OBJPROP_TIME2,    iTime(NULL,0,0));
}


void SetUpBound2(string name2, double up, double down,int objType=OBJ_RECTANGLE)
{
   if (ObjectFind(name2) == -1)
      {
         ObjectCreate(name2,objType,WindowFind(ShortName),0,0);
         ObjectSet(name2,OBJPROP_PRICE1,up);
         ObjectSet(name2,OBJPROP_PRICE2,down);
         ObjectSet(name2,OBJPROP_COLOR,Level2Color);
         ObjectSet(name2,OBJPROP_BACK,true);
         ObjectSet(name2,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name2,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name2,OBJPROP_TIME2,    iTime(NULL,0,0));
}

void SetUpBound3(string name3, double up, double down,int objType=OBJ_RECTANGLE)
{
   if (ObjectFind(name3) == -1)
      {
         ObjectCreate(name3,objType,WindowFind(ShortName),0,0);
         ObjectSet(name3,OBJPROP_PRICE1,up);
         ObjectSet(name3,OBJPROP_PRICE2,down);
         ObjectSet(name3,OBJPROP_COLOR,Level3Color);
         ObjectSet(name3,OBJPROP_BACK,true);
         ObjectSet(name3,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name3,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name3,OBJPROP_TIME2,    iTime(NULL,0,0));
}

//---


